#ifndef BOARD_H
#define BOARD_H (1)

#include <iostream>
#include <stdint.h>

namespace gol
{
    /** A generic game board implementation. */
    class Board
    {

        public:
            Board(uint8_t width = 10, uint8_t height = 10, uint16_t historyLevels = 50);
            ~Board(void);

            void putGlider(void);
            void randomiseBoard(uint8_t fillFactor = 0x7FU);
            uint8_t getWidth(void) const;
            uint8_t getHeight(void) const;
            int checkStateMatch(void) const;
            void recordState(void);

            virtual bool play(void) = 0;

            /* Stream output routine */
            friend std::ostream& operator<<(std::ostream &os, const Board &b);

        protected:
            uint8_t *grid;
            uint8_t **history;
            uint8_t width;
            uint8_t height;
            uint16_t historyLevels;

            uint16_t cell(uint8_t x, uint8_t y) const;
    };

}

#endif
